diff --git a/src/main/java/net/minecraft/core/block/BlockBasket.java b/src/main/java/net/minecraft/core/block/BasketBlock.java
similarity index 52%
rename from src/main/java/net/minecraft/core/block/BlockBasket.java
rename to src/main/java/net/minecraft/core/block/BasketBlock.java
index 3ad1baa15..bcd5444d5 100644
--- a/src/main/java/net/minecraft/core/block/BlockBasket.java
+++ b/src/main/java/net/minecraft/core/block/BasketBlock.java
@@ -1,26 +1,26 @@
 package net.minecraft.core.block;
-import net.minecraft.core.block.entity.TileEntity;
-import net.minecraft.core.block.entity.TileEntityBasket;
+import net.minecraft.core.block.entity.BlockEntity;
+import net.minecraft.core.block.entity.BasketBlockEntity;
 import net.minecraft.core.block.material.Material;
-import net.minecraft.core.entity.player.EntityPlayer;
+import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.enums.EnumDropCause;
-import net.minecraft.core.item.Item;
+import net.minecraft.core.item.Items;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.WorldSource;
 import net.minecraft.core.world.World;
 
-public class BlockBasket extends BlockTileEntity
+public class BasketBlock extends EntityBlock
 {
-    protected BlockBasket(final String blockName, int id, final Material material)
+    protected BasketBlock(final String blockName, String namespaceId, int id, final Material material)
     {
-        super(blockName, id, material);
+        super(blockName, namespaceId, id, material);
     }
 
     @Override
-    public boolean onBlockRightClicked(final World world, final int x, final int y, final int z, final EntityPlayer entityplayer, Side side, double xPlaced, double yPlaced)
+    public boolean onBlockRightClicked(final World world, final int x, final int y, final int z, final Player entityplayer, Side side, double xPlaced, double yPlaced)
     {
-        final TileEntityBasket te = (TileEntityBasket) world.getBlockTileEntity(x, y, z);
+        final BasketBlockEntity te = (BasketBlockEntity) world.getBlockEntity(x, y, z);
 
         if (te.getNumUnitsInside() > 0)
         {
@@ -33,19 +33,19 @@ public class BlockBasket extends BlockTileEntity
     }
 
     @Override
-    public boolean renderAsNormalBlock() {
+    public boolean isCubeShaped() {
         return false;
     }
 
     @Override
-    protected TileEntity getNewBlockEntity()
+    protected BlockEntity getNewBlockEntity()
     {
-        return new TileEntityBasket();
+        return new BasketBlockEntity();
     }
 
     public int getFillLevel(final WorldSource world, final int x, final int y, final int z)
     {
-        final TileEntityBasket te = (TileEntityBasket) world.getBlockTileEntity(x, y, z);
+        final BasketBlockEntity te = (BasketBlockEntity) world.getBlockEntity(x, y, z);
 
         final float fill = te.getNumUnitsInside() / (float)te.getMaxUnits();
 
@@ -61,7 +61,7 @@ public class BlockBasket extends BlockTileEntity
     @Override
     public void onBlockRemoved(final World world, final int x, final int y, final int z, int data)
     {
-        final TileEntityBasket te = (TileEntityBasket) world.getBlockTileEntity(x, y, z);
+        final BasketBlockEntity te = (BasketBlockEntity) world.getBlockEntity(x, y, z);
         world.removeBlockTileEntity(x, y, z);
         if (world.isClientSide) return;
         te.dropAllItems();
@@ -69,20 +69,20 @@ public class BlockBasket extends BlockTileEntity
 
 
     @Override
-    public boolean canProvidePower()
+    public boolean isSignalSource()
     {
         return true;
     }
 
     @Override
-    public boolean isIndirectlyPoweringTo(World world, int x, int y, int z, int side)
+    public boolean getDirectSignal(World world, int x, int y, int z, Side side)
     {
-        return isPoweringTo(world, x, y, z, side);
+        return getSignal(world, x, y, z, side);
     }
     @Override
-    public boolean isPoweringTo(WorldSource blockAccess, int x, int y, int z, int side)
+    public boolean getSignal(WorldSource blockAccess, int x, int y, int z, Side side)
     {
-        TileEntityBasket basketTileEntity = (TileEntityBasket) blockAccess.getBlockTileEntity(x, y, z);
+        BasketBlockEntity basketTileEntity = (BasketBlockEntity) blockAccess.getBlockEntity(x, y, z);
         if(basketTileEntity != null){
             return basketTileEntity.getNumUnitsInside() == basketTileEntity.getMaxUnits();
         }
@@ -90,8 +90,8 @@ public class BlockBasket extends BlockTileEntity
     }
 
     @Override
-    public ItemStack[] getBreakResult(World world, EnumDropCause dropCause, int x, int y, int z, int meta, TileEntity tileEntity)
+    public ItemStack[] getBreakResult(World world, EnumDropCause dropCause, int x, int y, int z, int meta, BlockEntity blockEntity)
     {
-        return new ItemStack[] { new ItemStack(Item.basket) };
+        return new ItemStack[] { new ItemStack(Items.BASKET) };
     }
 }
\ No newline at end of file
diff --git a/src/main/java/net/minecraft/core/block/BlockBed.java b/src/main/java/net/minecraft/core/block/BedBlock.java
similarity index 51%
rename from src/main/java/net/minecraft/core/block/BlockBed.java
rename to src/main/java/net/minecraft/core/block/BedBlock.java
index cbe0c92b2..93c9b0e86 100644
--- a/src/main/java/net/minecraft/core/block/BlockBed.java
+++ b/src/main/java/net/minecraft/core/block/BedBlock.java
@@ -1,26 +1,26 @@
 package net.minecraft.core.block;
 
-import net.minecraft.core.block.entity.TileEntity;
+import net.minecraft.core.block.entity.BlockEntity;
 import net.minecraft.core.block.material.Material;
-import net.minecraft.core.entity.player.EntityPlayer;
+import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.enums.EnumDropCause;
 import net.minecraft.core.enums.EnumSleepStatus;
-import net.minecraft.core.item.Item;
+import net.minecraft.core.item.Items;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.WorldSource;
 import net.minecraft.core.world.chunk.ChunkCoordinates;
 
-public class BlockBed extends Block {
+public class BedBlock extends Block {
 
-	public BlockBed(String key, int id) {
-		super(key, id, Material.wood);
+	public BedBlock(String key, String namespaceId, int id) {
+		super(key, namespaceId, id, Material.wood);
 		setBounds();
 	}
 
 	@Override
-	public boolean onBlockRightClicked(World world, int x, int y, int z, EntityPlayer player, Side side, double xPlaced, double yPlaced) {
+	public boolean onBlockRightClicked(World world, int x, int y, int z, Player player, Side side, double xPlaced, double yPlaced) {
 		if(world.isClientSide) {
 			return true;
 		}
@@ -28,9 +28,9 @@ public class BlockBed extends Block {
 		// Offset coords to foot end of bed, leave if bed is not complete
 		int meta = world.getBlockMetadata(x, y, z);
 		if(!isBlockFootOfBed(meta)) {
-			int dir = getDirectionFromMetadata(meta);
-			x += headBlockToFootBlockMap[dir][0];
-			z += headBlockToFootBlockMap[dir][1];
+			int dir = getDirection(meta);
+			x += headBlockToFootBlockMap[dir].getOffsetX();
+			z += headBlockToFootBlockMap[dir].getOffsetZ();
 			if(world.getBlockId(x, y, z) != id) {
 				return true;
 			}
@@ -39,27 +39,21 @@ public class BlockBed extends Block {
 
 		// Explode in invalid dimensions
 		if(!world.worldType.mayRespawn()) {
-			double d = (double) x + 0.5D;
-			double d1 = (double) y + 0.5D;
-			double d2 = (double) z + 0.5D;
-			world.setBlockWithNotify(x, y, z, 0);
-			int dir = getDirectionFromMetadata(meta);
-			x += headBlockToFootBlockMap[dir][0];
-			z += headBlockToFootBlockMap[dir][1];
+            world.setBlockWithNotify(x, y, z, 0);
+			int dir = getDirection(meta);
+			x += headBlockToFootBlockMap[dir].getOffsetX();
+			z += headBlockToFootBlockMap[dir].getOffsetZ();
 			if(world.getBlockId(x, y, z) == id) {
 				world.setBlockWithNotify(x, y, z, 0);
-				d = (d + (double) x + 0.5D) / 2D;
-				d1 = (d1 + (double) y + 0.5D) / 2D;
-				d2 = (d2 + (double) z + 0.5D) / 2D;
-			}
+            }
 			world.newExplosion(null, (float) x + 0.5F, (float) y + 0.5F, (float) z + 0.5F, 5F, true, false);
 			return true;
 		}
 		
 		//Check if bed is occupied, and set occupied
 		if(isBedOccupied(meta)) {
-			EntityPlayer player1 = null;
-			for (EntityPlayer p : world.players) {
+			Player player1 = null;
+			for (Player p : world.players) {
 				if(p.isPlayerSleeping()) {
 					ChunkCoordinates pos = p.bedChunkCoordinates;
 					if(pos.x == x && pos.y == y && pos.z == z) {
@@ -85,7 +79,7 @@ public class BlockBed extends Block {
 	}
 
 	@Override
-	public boolean renderAsNormalBlock() {
+	public boolean isCubeShaped() {
 		return false;
 	}
 
@@ -101,13 +95,13 @@ public class BlockBed extends Block {
 
 	@Override
 	public void onNeighborBlockChange(World world, int x, int y, int z, int blockId) {
-		int i1 = world.getBlockMetadata(x, y, z);
-		int j1 = getDirectionFromMetadata(i1);
-		if(isBlockFootOfBed(i1)) {
-			if(world.getBlockId(x - headBlockToFootBlockMap[j1][0], y, z - headBlockToFootBlockMap[j1][1]) != id) {
+		int metadata = world.getBlockMetadata(x, y, z);
+		int direction = getDirection(metadata);
+		if(isBlockFootOfBed(metadata)) {
+			if(world.getBlockId(x - headBlockToFootBlockMap[direction].getOffsetX(), y, z - headBlockToFootBlockMap[direction].getOffsetZ()) != id) {
 				world.setBlockWithNotify(x, y, z, 0);
 			}
-		} else if(world.getBlockId(x + headBlockToFootBlockMap[j1][0], y, z + headBlockToFootBlockMap[j1][1]) != id) {
+		} else if(world.getBlockId(x + headBlockToFootBlockMap[direction].getOffsetX(), y, z + headBlockToFootBlockMap[direction].getOffsetZ()) != id) {
 			world.setBlockWithNotify(x, y, z, 0);
 		}
 	}
@@ -116,45 +110,59 @@ public class BlockBed extends Block {
 		setBlockBounds(0.0F, 0.0F, 0.0F, 1.0F, 0.5625F, 1.0F);
 	}
 
-	public static int getDirectionFromMetadata(int i) {
-		return i & 3;
+	@Override
+	public ItemStack[] getBreakResult(World world, EnumDropCause dropCause, int x, int y, int z, int meta, BlockEntity blockEntity)
+	{
+		return new ItemStack[] { new ItemStack(Items.BED) };
+	}
+
+	@Override
+	public int getPistonPushReaction() {
+		return 1;
+	}
+
+	public static final int MASK_IS_FOOT = 0b0000_1000;
+	public static final int MASK_IS_OCCUPIED = 0b0000_0100;
+	public static final int MASK_DIRECTION = 0b0000_0011;
+	public static boolean isBlockFootOfBed(int meta) {
+		return (meta & MASK_IS_FOOT) != 0;
 	}
 
-	public static boolean isBlockFootOfBed(int i) {
-		return (i & 8) != 0;
+	public static boolean isBedOccupied(int meta) {
+		return (meta & MASK_IS_OCCUPIED) != 0;
 	}
 
-	public static boolean isBedOccupied(int i) {
-		return (i & 4) != 0;
+	public static int getDirection(int meta) {
+		return meta & MASK_DIRECTION;
 	}
 
 	public static void setBedOccupied(World world, int i, int j, int k, boolean flag) {
 		int l = world.getBlockMetadata(i, j, k);
 		if(flag) {
-			l |= 4;
+			l |= MASK_IS_OCCUPIED;
 		} else {
-			l &= -5;
+			l &= ~MASK_IS_OCCUPIED;
 		}
 		world.setBlockMetadataWithNotify(i, j, k, l);
 	}
 
-	public static ChunkCoordinates getNearestEmptyChunkCoordinates(World world, int i, int j, int k, int l) {
-		int i1 = world.getBlockMetadata(i, j, k);
-		int j1 = getDirectionFromMetadata(i1);
+	public static ChunkCoordinates getNearestEmptyChunkCoordinates(World world, int x, int y, int z, int l) {
+		int meta = world.getBlockMetadata(x, y, z);
+		int direction = getDirection(meta);
 		for (int k1 = 0; k1 <= 1; k1++) {
-			int l1 = i - headBlockToFootBlockMap[j1][0] * k1 - 1;
-			int i2 = k - headBlockToFootBlockMap[j1][1] * k1 - 1;
+			int l1 = x - headBlockToFootBlockMap[direction].getOffsetX() * k1 - 1;
+			int i2 = z - headBlockToFootBlockMap[direction].getOffsetZ() * k1 - 1;
 			int j2 = l1 + 2;
 			int k2 = i2 + 2;
 			for (int l2 = l1; l2 <= j2; l2++) {
 				for (int i3 = i2; i3 <= k2; i3++) {
-					if(!world.isBlockNormalCube(l2, j - 1, i3) || !world.isAirBlock(l2, j, i3) || !world.isAirBlock(l2, j + 1, i3)) {
+					if(!world.isBlockNormalCube(l2, y - 1, i3) || !world.isAirBlock(l2, y, i3) || !world.isAirBlock(l2, y + 1, i3)) {
 						continue;
 					}
 					if(l > 0) {
 						l--;
 					} else {
-						return new ChunkCoordinates(l2, j, i3);
+						return new ChunkCoordinates(l2, y, i3);
 					}
 				}
 
@@ -165,17 +173,29 @@ public class BlockBed extends Block {
 		return null;
 	}
 
-	@Override
-	public ItemStack[] getBreakResult(World world, EnumDropCause dropCause, int x, int y, int z, int meta, TileEntity tileEntity)
-	{
-		return new ItemStack[] { new ItemStack(Item.bed) };
-	}
-
-	@Override
-	public int getPistonPushReaction() {
-		return 1;
+	public static final int[] headOfBedMap = {
+		3, 4, 2, 5
+	};
+	public static final int[] footToHeadMap = {
+		2, 3, 0, 1
+	};
+	public static final int[][] bedDirection = {
+		{
+			1, 0, 3, 2, 5, 4
+		}, {
+			1, 0, 5, 4, 2, 3
+	}, {
+		1, 0, 2, 3, 4, 5
+	}, {
+		1, 0, 4, 5, 3, 2
 	}
-
-	public static final int[][] headBlockToFootBlockMap = { { 0, 1 }, { -1, 0 }, { 0, -1 }, { 1, 0 } };
-
+	};
+
+	public static final Side[] headBlockToFootBlockMap =
+		{
+			Side.SOUTH,
+			Side.WEST,
+			Side.NORTH,
+			Side.EAST
+		};
 }
diff --git a/src/main/java/net/minecraft/core/block/BedrockBlock.java b/src/main/java/net/minecraft/core/block/BedrockBlock.java
new file mode 100644
index 000000000..7136fa1e5
--- /dev/null
+++ b/src/main/java/net/minecraft/core/block/BedrockBlock.java
@@ -0,0 +1,21 @@
+package net.minecraft.core.block;
+
+import net.minecraft.core.block.material.Material;
+import net.minecraft.core.world.World;
+
+public class BedrockBlock
+	extends Block
+{
+	public BedrockBlock(String key, String namespaceId, int id, Material material)
+    {
+		super(key, namespaceId, id, material);
+	}
+
+	@Override
+	public void onBlockPlacedByWorld(World world, int x, int y, int z)
+    {
+        if (world.getBlockId(x, y - 1, z) == Blocks.GLOWSTONE.id) {
+            ((PortalBlock) Blocks.PORTAL_PARADISE).tryToCreatePortal(world, x, y, z);
+        }
+    }
+}
diff --git a/src/main/java/net/minecraft/core/block/BirchLeavesBlock.java b/src/main/java/net/minecraft/core/block/BirchLeavesBlock.java
new file mode 100644
index 000000000..a56d3b60b
--- /dev/null
+++ b/src/main/java/net/minecraft/core/block/BirchLeavesBlock.java
@@ -0,0 +1,24 @@
+package net.minecraft.core.block;
+
+import net.minecraft.core.block.material.Material;
+
+// Referenced classes of package net.minecraft.src:
+//            BaseLeavesBlock, Material, ColorizerFoliage, IBlockAccess,
+//            WorldChunkManager, World, Block, Player,
+//            ItemStack, Item, ItemShears, StatList, 
+//            Entity
+
+public class BirchLeavesBlock extends BaseLeavesBlock
+{
+
+	public BirchLeavesBlock(String key, String namespaceId, int id)
+    {
+        super(key, namespaceId, id, Material.leaves);
+    }
+
+    @Override
+    protected Block getSapling()
+    {
+        return Blocks.SAPLING_BIRCH;
+    }
+}
diff --git a/src/main/java/net/minecraft/core/block/BlockBlastFurnace.java b/src/main/java/net/minecraft/core/block/BlastFurnaceBlock.java
similarity index 68%
rename from src/main/java/net/minecraft/core/block/BlockBlastFurnace.java
rename to src/main/java/net/minecraft/core/block/BlastFurnaceBlock.java
index 405ede2c7..ab6f38d49 100644
--- a/src/main/java/net/minecraft/core/block/BlockBlastFurnace.java
+++ b/src/main/java/net/minecraft/core/block/BlastFurnaceBlock.java
@@ -1,9 +1,9 @@
 package net.minecraft.core.block;
 
 import net.minecraft.core.Global;
-import net.minecraft.core.block.entity.TileEntity;
-import net.minecraft.core.block.entity.TileEntityBlastFurnace;
-import net.minecraft.core.entity.player.EntityPlayer;
+import net.minecraft.core.block.entity.BlockEntity;
+import net.minecraft.core.block.entity.BlastFurnaceBlockEntity;
+import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.enums.EnumDropCause;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.util.helper.Side;
@@ -13,20 +13,20 @@ import java.util.Random;
 
 // Referenced classes of package net.minecraft.src:
 //            BlockContainer, Material, Block, World,
-//            IBlockAccess, TileEntityFurnace, EntityPlayer, TileEntity,
-//            EntityLiving, MathHelper, IInventory, ItemStack,
-//            EntityItem
+//            IBlockAccess, FurnaceBlockEntity, Player, BlockEntity,
+//            Mob, MathHelper, IInventory, ItemStack,
+//            ItemEntity
 
-public class BlockBlastFurnace extends BlockFurnace
+public class BlastFurnaceBlock extends FurnaceBlock
 {
 
-	public BlockBlastFurnace(String key, int id, boolean flag)
+	public BlastFurnaceBlock(String key, String namespaceId, int id, boolean flag)
     {
-        super(key, id, flag);
+        super(key, namespaceId, id, flag);
     }
 
     @Override
-    public ItemStack[] getBreakResult(World world, EnumDropCause dropCause, int x, int y, int z, int meta, TileEntity tileEntity)
+    public ItemStack[] getBreakResult(World world, EnumDropCause dropCause, int x, int y, int z, int meta, BlockEntity blockEntity)
     {
         switch (dropCause)
         {
@@ -34,28 +34,24 @@ public class BlockBlastFurnace extends BlockFurnace
             case EXPLOSION:
             case PROPER_TOOL:
             case SILK_TOUCH:
-                return new ItemStack[] { new ItemStack(Block.furnaceBlastIdle) };
+                return new ItemStack[] { new ItemStack(Blocks.FURNACE_BLAST_IDLE) };
             default:
                 return null;
         }
     }
 
     @Override
-    public boolean onBlockRightClicked(World world, int x, int y, int z, EntityPlayer player, Side side, double xPlaced, double yPlaced)
+    public boolean onBlockRightClicked(World world, int x, int y, int z, Player player, Side side, double xPlaced, double yPlaced)
     {
-        if(world.isClientSide)
-        {
-            return true;
-        } else
-        {
-            TileEntityBlastFurnace tileentityblastfurnace = (TileEntityBlastFurnace)world.getBlockTileEntity(x, y, z);
+        if (!world.isClientSide) {
+            BlastFurnaceBlockEntity tileentityblastfurnace = (BlastFurnaceBlockEntity) world.getBlockEntity(x, y, z);
             player.displayGUIFurnace(tileentityblastfurnace);
-            return true;
         }
+        return true;
     }
 
     @Override
-	public void randomDisplayTick(World world, int x, int y, int z, Random rand)
+	public void animationTick(World world, int x, int y, int z, Random rand)
     {
         if(!isActive)
         {
@@ -91,7 +87,7 @@ public class BlockBlastFurnace extends BlockFurnace
 
 	public static void updateFurnaceBlockState(boolean lit, World world, int x, int y, int z) {
 		int meta = world.getBlockMetadata(x, y, z);
-		TileEntity tileentity = world.getBlockTileEntity(x, y, z);
+		BlockEntity tileentity = world.getBlockEntity(x, y, z);
 		if(tileentity == null) {
 			String msg = "Blast Furnace is missing Tile Entity at x: "+x+" y: "+y+" z: "+z+", block will be removed!";
 			if(Global.BUILD_CHANNEL.isUnstableBuild()) {
@@ -103,9 +99,9 @@ public class BlockBlastFurnace extends BlockFurnace
 		}
 		keepFurnaceInventory = true;
 		if(lit) {
-			world.setBlockWithNotify(x, y, z, Block.furnaceBlastActive.id);
+			world.setBlockWithNotify(x, y, z, Blocks.FURNACE_BLAST_ACTIVE.id);
 		} else {
-			world.setBlockWithNotify(x, y, z, Block.furnaceBlastIdle.id);
+			world.setBlockWithNotify(x, y, z, Blocks.FURNACE_BLAST_IDLE.id);
 		}
 		keepFurnaceInventory = false;
 		world.setBlockMetadataWithNotify(x, y, z, meta);
@@ -114,9 +110,9 @@ public class BlockBlastFurnace extends BlockFurnace
 	}
 
     @Override
-	protected TileEntity getNewBlockEntity()
+	protected BlockEntity getNewBlockEntity()
     {
-        return new TileEntityBlastFurnace();
+        return new BlastFurnaceBlockEntity();
     }
 
 }
